
        private string GetCssColorOutput(Color colColor)
        {
            string strColor;

            // Is the color a named color?
            bool named = false;
            string hex = ColorToHexString(colColor);
            string name = HexToNamedColor(hex);
            if (name != "")
            {
                named = true;
            }

            switch (ShowColorAsText)
            {
                case (int)TextType.Hex:
                    strColor = "#" + ColorToHexString(colColor).ToUpper();
                    break;

                case (int)TextType.RGB:
                    strColor = "rgb(" + ColorToRgb(colColor) + ")"; 
                    break;

                case (int)TextType.Named:
                    if (named == true)
                    {
                        strColor = name;
                    }
                    else
                    {
                        strColor = "#" + ColorToHexString(colColor).ToUpper();
                    }
                    break;

                case (int)TextType.NamedHex:
                    if (named == true)
                    {
                        strColor = name;
                    }
                    else
                    {
                        strColor = "#" + ColorToHexString(colColor).ToUpper();
                    }
                    break;

                case (int)TextType.NamedRGB:
                    if (named == true)
                    {
                        strColor = name;
                    }
                    else
                    {
                        strColor = "rgb(" + ColorToRgb(colColor) + ")"; 
                    }
                    break;

                default:
                    strColor = "#" + ColorToHexString(colColor).ToUpper();
                    break;
            }
            return strColor;
        }



        private string ColorToRgb(Color colColor)
        {
            int r, g, b;
            r = colColor.R;
            g = colColor.G;
            b = colColor.B;
            return r.ToString() + ", " + g.ToString() + ", " + b.ToString();
        }





        #region "Long color stuff with names"
        
        static char[] hexDigits = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };

        public static string ColorToHexString(Color color)
        {
            byte[] bytes = new byte[3];
            bytes[0] = color.R;
            bytes[1] = color.G;
            bytes[2] = color.B;
            char[] chars = new char[bytes.Length * 2];
            for (int i = 0; i < bytes.Length; i++)
            {
                int b = bytes[i];
                chars[i * 2] = hexDigits[b >> 4];
                chars[i * 2 + 1] = hexDigits[b & 0xF];
            }
            return new string(chars);
        }


        public bool IsNamedColor(String strColor)
        {
            bool IsNamed;

            switch (strColor.Trim().ToLower())
            {
                case "aliceblue":
                    IsNamed = true;
                    break;

                case "antiquewhite":
                    IsNamed = true;
                    break;

                case "aqua":
                    IsNamed = true;
                    break;

                case "aquamarine":
                    IsNamed = true;
                    break;

                case "azure":
                    IsNamed = true;
                    break;

                case "beige":
                    IsNamed = true;
                    break;

                case "bisque":
                    IsNamed = true;
                    break;

                case "black":
                    IsNamed = true;
                    break;

                case "blanchedalmond":
                    IsNamed = true;
                    break;

                case "blue":
                    IsNamed = true;
                    break;

                case "blueviolet":
                    IsNamed = true;
                    break;

                case "brown":
                    IsNamed = true;
                    break;

                case "burlywood":
                    IsNamed = true;
                    break;

                case "cadetblue":
                    IsNamed = true;
                    break;

                case "chartreuse":
                    IsNamed = true;
                    break;

                case "chocolate":
                    IsNamed = true;
                    break;

                case "coral":
                    IsNamed = true;
                    break;

                case "cornflowerblue":
                    IsNamed = true;
                    break;

                case "cornsilk":
                    IsNamed = true;
                    break;

                case "crimson":
                    IsNamed = true;
                    break;

                case "cyan":
                    IsNamed = true;
                    break;

                case "darkblue":
                    IsNamed = true;
                    break;

                case "darkcyan":
                    IsNamed = true;
                    break;

                case "darkgoldenrod":
                    IsNamed = true;
                    break;

                case "darkgray":
                    IsNamed = true;
                    break;

                case "darkgrey":
                    IsNamed = true;
                    break;

                case "darkgreen":
                    IsNamed = true;
                    break;

                case "darkkhaki":
                    IsNamed = true;
                    break;

                case "darkmagenta":
                    IsNamed = true;
                    break;

                case "darkolivegreen":
                    IsNamed = true;
                    break;

                case "darkorange":
                    IsNamed = true;
                    break;

                case "darkorchid":
                    IsNamed = true;
                    break;

                case "darkred":
                    IsNamed = true;
                    break;

                case "darksalmon":
                    IsNamed = true;
                    break;

                case "darkseagreen":
                    IsNamed = true;
                    break;

                case "darkslateblue":
                    IsNamed = true;
                    break;

                case "darkslategray":
                    IsNamed = true;
                    break;

                case "darkslategrey":
                    IsNamed = true;
                    break;

                case "darkturquoise":
                    IsNamed = true;
                    break;

                case "darkviolet":
                    IsNamed = true;
                    break;

                case "deeppink":
                    IsNamed = true;
                    break;

                case "deepskyblue":
                    IsNamed = true;
                    break;

                case "dimgray":
                    IsNamed = true;
                    break;

                case "dimgrey":
                    IsNamed = true;
                    break;

                case "dodgerblue":
                    IsNamed = true;
                    break;

                case "firebrick":
                    IsNamed = true;
                    break;

                case "floralwhite":
                    IsNamed = true;
                    break;

                case "forestgreen":
                    IsNamed = true;
                    break;

                case "fuchsia":
                    IsNamed = true;
                    break;

                case "gainsboro":
                    IsNamed = true;
                    break;

                case "ghostwhite":
                    IsNamed = true;
                    break;

                case "gold":
                    IsNamed = true;
                    break;

                case "goldenrod":
                    IsNamed = true;
                    break;

                case "gray":
                    IsNamed = true;
                    break;

                case "grey":
                    IsNamed = true;
                    break;

                case "green":
                    IsNamed = true;
                    break;

                case "greenyellow":
                    IsNamed = true;
                    break;

                case "honeydew":
                    IsNamed = true;
                    break;

                case "hotpink":
                    IsNamed = true;
                    break;

                case "indianred":
                    IsNamed = true;
                    break;

                case "indigo":
                    IsNamed = true;
                    break;

                case "ivory":
                    IsNamed = true;
                    break;

                case "khaki":
                    IsNamed = true;
                    break;

                case "lavender":
                    IsNamed = true;
                    break;

                case "lavenderblush":
                    IsNamed = true;
                    break;

                case "lawngreen":
                    IsNamed = true;
                    break;

                case "lemonchiffon":
                    IsNamed = true;
                    break;

                case "lightblue":
                    IsNamed = true;
                    break;

                case "lightcoral":
                    IsNamed = true;
                    break;

                case "lightcyan":
                    IsNamed = true;
                    break;

                case "lightgoldenrodyellow":
                    IsNamed = true;
                    break;

                case "lightgray":
                    IsNamed = true;
                    break;

                case "lightgrey":
                    IsNamed = true;
                    break;

                case "lightgreen":
                    IsNamed = true;
                    break;

                case "lightpink":
                    IsNamed = true;
                    break;

                case "lightsalmon":
                    IsNamed = true;
                    break;

                case "lightseagreen":
                    IsNamed = true;
                    break;

                case "lightskyblue":
                    IsNamed = true;
                    break;

                case "lightslategray":
                    IsNamed = true;
                    break;

                case "lightslategrey":
                    IsNamed = true;
                    break;

                case "lightsteelblue":
                    IsNamed = true;
                    break;

                case "lightyellow":
                    IsNamed = true;
                    break;

                case "lime":
                    IsNamed = true;
                    break;

                case "limegreen":
                    IsNamed = true;
                    break;

                case "linen":
                    IsNamed = true;
                    break;

                case "magenta":
                    IsNamed = true;
                    break;

                case "maroon":
                    IsNamed = true;
                    break;

                case "mediumaquamarine":
                    IsNamed = true;
                    break;

                case "mediumblue":
                    IsNamed = true;
                    break;

                case "mediumorchid":
                    IsNamed = true;
                    break;

                case "mediumpurple":
                    IsNamed = true;
                    break;

                case "mediumseagreen":
                    IsNamed = true;
                    break;

                case "mediumslateblue":
                    IsNamed = true;
                    break;

                case "mediumspringgreen":
                    IsNamed = true;
                    break;

                case "mediumturquoise":
                    IsNamed = true;
                    break;

                case "mediumvioletred":
                    IsNamed = true;
                    break;

                case "midnightblue":
                    IsNamed = true;
                    break;

                case "mintcream":
                    IsNamed = true;
                    break;

                case "mistyrose":
                    IsNamed = true;
                    break;

                case "moccasin":
                    IsNamed = true;
                    break;

                case "navajowhite":
                    IsNamed = true;
                    break;

                case "navy":
                    IsNamed = true;
                    break;

                case "oldlace":
                    IsNamed = true;
                    break;

                case "olive":
                    IsNamed = true;
                    break;

                case "olivedrab":
                    IsNamed = true;
                    break;

                case "orange":
                    IsNamed = true;
                    break;

                case "orangered":
                    IsNamed = true;
                    break;

                case "orchid":
                    IsNamed = true;
                    break;

                case "palegoldenrod":
                    IsNamed = true;
                    break;

                case "palegreen":
                    IsNamed = true;
                    break;

                case "paleturquoise":
                    IsNamed = true;
                    break;

                case "palevioletred":
                    IsNamed = true;
                    break;

                case "papayawhip":
                    IsNamed = true;
                    break;

                case "peachpuff":
                    IsNamed = true;
                    break;

                case "peru":
                    IsNamed = true;
                    break;

                case "pink":
                    IsNamed = true;
                    break;

                case "plum":
                    IsNamed = true;
                    break;

                case "powderblue":
                    IsNamed = true;
                    break;

                case "purple":
                    IsNamed = true;
                    break;

                case "red":
                    IsNamed = true;
                    break;

                case "rosybrown":
                    IsNamed = true;
                    break;

                case "royalblue":
                    IsNamed = true;
                    break;

                case "saddlebrown":
                    IsNamed = true;
                    break;

                case "salmon":
                    IsNamed = true;
                    break;

                case "sandybrown":
                    IsNamed = true;
                    break;

                case "seagreen":
                    IsNamed = true;
                    break;

                case "seashell":
                    IsNamed = true;
                    break;

                case "sienna":
                    IsNamed = true;
                    break;

                case "silver":
                    IsNamed = true;
                    break;

                case "skyblue":
                    IsNamed = true;
                    break;

                case "slateblue":
                    IsNamed = true;
                    break;

                case "slategray":
                    IsNamed = true;
                    break;

                case "slategrey":
                    IsNamed = true;
                    break;

                case "snow":
                    IsNamed = true;
                    break;

                case "springgreen":
                    IsNamed = true;
                    break;

                case "steelblue":
                    IsNamed = true;
                    break;

                case "tan":
                    IsNamed = true;
                    break;

                case "teal":
                    IsNamed = true;
                    break;

                case "thistle":
                    IsNamed = true;
                    break;

                case "tomato":
                    IsNamed = true;
                    break;

                case "turquoise":
                    IsNamed = true;
                    break;

                case "violet":
                    IsNamed = true;
                    break;

                case "wheat":
                    IsNamed = true;
                    break;

                case "white":
                    IsNamed = true;
                    break;

                case "whitesmoke":
                    IsNamed = true;
                    break;

                case "yellow":
                    IsNamed = true;
                    break;

                case "yellowgreen":
                    IsNamed = true;
                    break;


                default:
                    IsNamed = false;
                    break;
            }

            return IsNamed;
        }


        public Color HexToColor(String hexString)
        {

            // Before we do anything, we need to check if we have an RBG or a named color first.

            // Check for an RBG value...
            Color actColor;
            int r, g, b;
            r = 0;
            g = 0;
            b = 0;

            string rgbRegEx = @"rgb\([0-9]+,[0-9]+,[0-9]+\)";
            string rgbString = hexString.ToLower().Replace(" ", "");
            if (Regex.IsMatch(rgbString, rgbRegEx, RegexOptions.None))
            {
                return CssRgbToColor(hexString);
            }

            // Check if we have a Named Color
            if (IsNamedColor(hexString) == true)
            {
                return HexToColor(ColorNameToHex(hexString));
            }

            if ((hexString.StartsWith("#")) && (hexString.Length == 7))
            {
                r = HexToInt(hexString.Substring(1, 2));
                g = HexToInt(hexString.Substring(3, 2));
                b = HexToInt(hexString.Substring(5, 2));
                actColor = Color.FromArgb(r, g, b);
            }
            else if ((hexString.Length == 6) && !(hexString.StartsWith("#")))
            {
                r = HexToInt(hexString.Substring(0, 2));
                g = HexToInt(hexString.Substring(2, 2));
                b = HexToInt(hexString.Substring(4, 2));
                actColor = Color.FromArgb(r, g, b);
            }
            else if ((hexString.Length == 3) && !(hexString.StartsWith("#")))
            {
                r = HexToInt(hexString.Substring(0, 1) + hexString.Substring(0, 1));
                g = HexToInt(hexString.Substring(1, 1) + hexString.Substring(1, 1));
                b = HexToInt(hexString.Substring(2, 1) + hexString.Substring(2, 1));
                actColor = Color.FromArgb(r, g, b);
            }
            else if ((hexString.Length == 4) && (hexString.StartsWith("#")))
            {
                r = HexToInt(hexString.Substring(1, 1) + hexString.Substring(1, 1));
                g = HexToInt(hexString.Substring(2, 1) + hexString.Substring(2, 1));
                b = HexToInt(hexString.Substring(3, 1) + hexString.Substring(3, 1));
                actColor = Color.FromArgb(r, g, b);
            }
            else
            {
                actColor = HexToColor(ColorNameToHex(hexString));
            }
            return actColor;
        }


        public Color CssRgbToColor(String rgbString)
        {
            Color actColor;
            int r, g, b;
            
            rgbString = rgbString.Replace(" ", "").Replace("rgb(", "").Replace(")", "");

            string[] rgbArray = new string[3];
            char[] splitter = {','};

            rgbArray = rgbString.Split(splitter);

            try
            {
                r = Convert.ToInt16(rgbArray[0]);
            }
            catch
            {
                r = 255;
            }

            try
            {
                g = Convert.ToInt16(rgbArray[1]);
            }
            catch
            {
                g = 255;
            }

            try
            {
                b = Convert.ToInt16(rgbArray[2]);
            }
            catch
            {
                b = 255;
            }

            actColor = Color.FromArgb(r, g, b);
            return actColor;

        }


        public string ColorNameToHex(String strColor)
        {
            string strHex;

            switch (strColor.Trim().ToLower())
            {
                case "aliceblue":
                    strHex = "#F0F8FF";
                    break;

                case "antiquewhite":
                    strHex = "#FAEBD7";
                    break;

                case "aqua":
                    strHex = "#00FFFF";
                    break;

                case "aquamarine":
                    strHex = "#7FFFD4";
                    break;

                case "azure":
                    strHex = "#F0FFFF";
                    break;

                case "beige":
                    strHex = "#F5F5DC";
                    break;

                case "bisque":
                    strHex = "#FFE4C4";
                    break;

                case "black":
                    strHex = "#000000";
                    break;

                case "blanchedalmond":
                    strHex = "#FFEBCD";
                    break;

                case "blue":
                    strHex = "#0000FF";
                    break;

                case "blueviolet":
                    strHex = "#8A2BE2";
                    break;

                case "brown":
                    strHex = "#A52A2A";
                    break;

                case "burlywood":
                    strHex = "#DEB887";
                    break;

                case "cadetblue":
                    strHex = "#5F9EA0";
                    break;

                case "chartreuse":
                    strHex = "#7FFF00";
                    break;

                case "chocolate":
                    strHex = "#D2691E";
                    break;

                case "coral":
                    strHex = "#FF7F50";
                    break;

                case "cornflowerblue":
                    strHex = "#6495ED";
                    break;

                case "cornsilk":
                    strHex = "#FFF8DC";
                    break;

                case "crimson":
                    strHex = "#DC143C";
                    break;

                case "cyan":
                    strHex = "#00FFFF";
                    break;

                case "darkblue":
                    strHex = "#00008B";
                    break;

                case "darkcyan":
                    strHex = "#008B8B";
                    break;

                case "darkgoldenrod":
                    strHex = "#B8860B";
                    break;

                case "darkgray":
                    strHex = "#A9A9A9";
                    break;

                case "darkgrey":
                    strHex = "#A9A9A9";
                    break;

                case "darkgreen":
                    strHex = "#006400";
                    break;

                case "darkkhaki":
                    strHex = "#BDB76B";
                    break;

                case "darkmagenta":
                    strHex = "#8B008B";
                    break;

                case "darkolivegreen":
                    strHex = "#556B2F";
                    break;

                case "darkorange":
                    strHex = "#FF8C00";
                    break;

                case "darkorchid":
                    strHex = "#9932CC";
                    break;

                case "darkred":
                    strHex = "#8B0000";
                    break;

                case "darksalmon":
                    strHex = "#E9967A";
                    break;

                case "darkseagreen":
                    strHex = "#8FBC8F";
                    break;

                case "darkslateblue":
                    strHex = "#483D8B";
                    break;

                case "darkslategray":
                    strHex = "#2F4F4F";
                    break;

                case "darkslategrey":
                    strHex = "#2F4F4F";
                    break;

                case "darkturquoise":
                    strHex = "#00CED1";
                    break;

                case "darkviolet":
                    strHex = "#9400D3";
                    break;

                case "deeppink":
                    strHex = "#FF1493";
                    break;

                case "deepskyblue":
                    strHex = "#00BFFF";
                    break;

                case "dimgray":
                    strHex = "#696969";
                    break;

                case "dimgrey":
                    strHex = "#696969";
                    break;

                case "dodgerblue":
                    strHex = "#1E90FF";
                    break;

                case "firebrick":
                    strHex = "#B22222";
                    break;

                case "floralwhite":
                    strHex = "#FFFAF0";
                    break;

                case "forestgreen":
                    strHex = "#228B22";
                    break;

                case "fuchsia":
                    strHex = "#FF00FF";
                    break;

                case "gainsboro":
                    strHex = "#DCDCDC";
                    break;

                case "ghostwhite":
                    strHex = "#F8F8FF";
                    break;

                case "gold":
                    strHex = "#FFD700";
                    break;

                case "goldenrod":
                    strHex = "#DAA520";
                    break;

                case "gray":
                    strHex = "#808080";
                    break;

                case "grey":
                    strHex = "#808080";
                    break;

                case "green":
                    strHex = "#008000";
                    break;

                case "greenyellow":
                    strHex = "#ADFF2F";
                    break;

                case "honeydew":
                    strHex = "#F0FFF0";
                    break;

                case "hotpink":
                    strHex = "#FF69B4";
                    break;

                case "indianred":
                    strHex = "#CD5C5C";
                    break;

                case "indigo":
                    strHex = "#4B0082";
                    break;

                case "ivory":
                    strHex = "#FFFFF0";
                    break;

                case "khaki":
                    strHex = "#F0E68C";
                    break;

                case "lavender":
                    strHex = "#E6E6FA";
                    break;

                case "lavenderblush":
                    strHex = "#FFF0F5";
                    break;

                case "lawngreen":
                    strHex = "#7CFC00";
                    break;

                case "lemonchiffon":
                    strHex = "#FFFACD";
                    break;

                case "lightblue":
                    strHex = "#ADD8E6";
                    break;

                case "lightcoral":
                    strHex = "#F08080";
                    break;

                case "lightcyan":
                    strHex = "#E0FFFF";
                    break;

                case "lightgoldenrodyellow":
                    strHex = "#FAFAD2";
                    break;

                case "lightgray":
                    strHex = "#D3D3D3";
                    break;

                case "lightgrey":
                    strHex = "#D3D3D3";
                    break;

                case "lightgreen":
                    strHex = "#90EE90";
                    break;

                case "lightpink":
                    strHex = "#FFB6C1";
                    break;

                case "lightsalmon":
                    strHex = "#FFA07A";
                    break;

                case "lightseagreen":
                    strHex = "#20B2AA";
                    break;

                case "lightskyblue":
                    strHex = "#87CEFA";
                    break;

                case "lightslategray":
                    strHex = "#778899";
                    break;

                case "lightslategrey":
                    strHex = "#778899";
                    break;

                case "lightsteelblue":
                    strHex = "#B0C4DE";
                    break;

                case "lightyellow":
                    strHex = "#FFFFE0";
                    break;

                case "lime":
                    strHex = "#00FF00";
                    break;

                case "limegreen":
                    strHex = "#32CD32";
                    break;

                case "linen":
                    strHex = "#FAF0E6";
                    break;

                case "magenta":
                    strHex = "#FF00FF";
                    break;

                case "maroon":
                    strHex = "#800000";
                    break;

                case "mediumaquamarine":
                    strHex = "#66CDAA";
                    break;

                case "mediumblue":
                    strHex = "#0000CD";
                    break;

                case "mediumorchid":
                    strHex = "#BA55D3";
                    break;

                case "mediumpurple":
                    strHex = "#9370D8";
                    break;

                case "mediumseagreen":
                    strHex = "#3CB371";
                    break;

                case "mediumslateblue":
                    strHex = "#7B68EE";
                    break;

                case "mediumspringgreen":
                    strHex = "#00FA9A";
                    break;

                case "mediumturquoise":
                    strHex = "#48D1CC";
                    break;

                case "mediumvioletred":
                    strHex = "#C71585";
                    break;

                case "midnightblue":
                    strHex = "#191970";
                    break;

                case "mintcream":
                    strHex = "#F5FFFA";
                    break;

                case "mistyrose":
                    strHex = "#FFE4E1";
                    break;

                case "moccasin":
                    strHex = "#FFE4B5";
                    break;

                case "navajowhite":
                    strHex = "#FFDEAD";
                    break;

                case "navy":
                    strHex = "#000080";
                    break;

                case "oldlace":
                    strHex = "#FDF5E6";
                    break;

                case "olive":
                    strHex = "#808000";
                    break;

                case "olivedrab":
                    strHex = "#6B8E23";
                    break;

                case "orange":
                    strHex = "#FFA500";
                    break;

                case "orangered":
                    strHex = "#FF4500";
                    break;

                case "orchid":
                    strHex = "#DA70D6";
                    break;

                case "palegoldenrod":
                    strHex = "#EEE8AA";
                    break;

                case "palegreen":
                    strHex = "#98FB98";
                    break;

                case "paleturquoise":
                    strHex = "#AFEEEE";
                    break;

                case "palevioletred":
                    strHex = "#D87093";
                    break;

                case "papayawhip":
                    strHex = "#FFEFD5";
                    break;

                case "peachpuff":
                    strHex = "#FFDAB9";
                    break;

                case "peru":
                    strHex = "#CD853F";
                    break;

                case "pink":
                    strHex = "#FFC0CB";
                    break;

                case "plum":
                    strHex = "#DDA0DD";
                    break;

                case "powderblue":
                    strHex = "#B0E0E6";
                    break;

                case "purple":
                    strHex = "#800080";
                    break;

                case "red":
                    strHex = "#FF0000";
                    break;

                case "rosybrown":
                    strHex = "#BC8F8F";
                    break;

                case "royalblue":
                    strHex = "#4169E1";
                    break;

                case "saddlebrown":
                    strHex = "#8B4513";
                    break;

                case "salmon":
                    strHex = "#FA8072";
                    break;

                case "sandybrown":
                    strHex = "#F4A460";
                    break;

                case "seagreen":
                    strHex = "#2E8B57";
                    break;

                case "seashell":
                    strHex = "#FFF5EE";
                    break;

                case "sienna":
                    strHex = "#A0522D";
                    break;

                case "silver":
                    strHex = "#C0C0C0";
                    break;

                case "skyblue":
                    strHex = "#87CEEB";
                    break;

                case "slateblue":
                    strHex = "#6A5ACD";
                    break;

                case "slategray":
                    strHex = "#708090";
                    break;

                case "slategrey":
                    strHex = "#708090";
                    break;

                case "snow":
                    strHex = "#FFFAFA";
                    break;

                case "springgreen":
                    strHex = "#00FF7F";
                    break;

                case "steelblue":
                    strHex = "#4682B4";
                    break;

                case "tan":
                    strHex = "#D2B48C";
                    break;

                case "teal":
                    strHex = "#008080";
                    break;

                case "thistle":
                    strHex = "#D8BFD8";
                    break;

                case "tomato":
                    strHex = "#FF6347";
                    break;

                case "turquoise":
                    strHex = "#40E0D0";
                    break;

                case "violet":
                    strHex = "#EE82EE";
                    break;

                case "wheat":
                    strHex = "#F5DEB3";
                    break;

                case "white":
                    strHex = "#FFFFFF";
                    break;

                case "whitesmoke":
                    strHex = "#F5F5F5";
                    break;

                case "yellow":
                    strHex = "#FFFF00";
                    break;

                case "yellowgreen":
                    strHex = "#9ACD32";
                    break;


                default:
                    strHex = "#FFFFFF";
                    break;
            }

            return strHex;
        }


        private string HexToNamedColor(string hexColor)
        {
            string strNamedColor;

            hexColor = hexColor.Replace("#", "").ToUpper();

            string strR, strG, strB;

            if (hexColor.Length == 3)
            {
                strR = hexColor.Substring(0, 1) + hexColor.Substring(0, 1);
                strG = hexColor.Substring(1, 1) + hexColor.Substring(1, 1);
                strB = hexColor.Substring(2, 1) + hexColor.Substring(2, 1);
                hexColor = strR + strG + strB;
            }
            else if (hexColor.Length == 8)
            {
                strR = hexColor.Substring(2, 2);
                strG = hexColor.Substring(4, 2);
                strB = hexColor.Substring(6, 2);
                hexColor = strR + strG + strB;
            }


            switch (hexColor)
            {
                case "F0F8FF":
                    strNamedColor = "AliceBlue";
                    break;

                case "FAEBD7":
                    strNamedColor = "AntiqueWhite";
                    break;

                //case "00FFFF":
                //    strNamedColor = "Aqua";
                //    break;

                case "7FFFD4":
                    strNamedColor = "Aquamarine";
                    break;

                case "F0FFFF":
                    strNamedColor = "Azure";
                    break;

                case "F5F5DC":
                    strNamedColor = "Beige";
                    break;

                case "FFE4C4":
                    strNamedColor = "Bisque";
                    break;

                case "000000":
                    strNamedColor = "Black";
                    break;

                case "FFEBCD":
                    strNamedColor = "BlanchedAlmond";
                    break;

                case "0000FF":
                    strNamedColor = "Blue";
                    break;

                case "8A2BE2":
                    strNamedColor = "BlueViolet";
                    break;

                case "A52A2A":
                    strNamedColor = "Brown";
                    break;

                case "DEB887":
                    strNamedColor = "BurlyWood";
                    break;

                case "5F9EA0":
                    strNamedColor = "CadetBlue";
                    break;

                case "7FFF00":
                    strNamedColor = "Chartreuse";
                    break;

                case "D2691E":
                    strNamedColor = "Chocolate";
                    break;

                case "FF7F50":
                    strNamedColor = "Coral";
                    break;

                case "6495ED":
                    strNamedColor = "CornflowerBlue";
                    break;

                case "FFF8DC":
                    strNamedColor = "Cornsilk";
                    break;

                case "DC143C":
                    strNamedColor = "Crimson";
                    break;

                case "00FFFF":
                    strNamedColor = "Cyan";
                    break;

                case "00008B":
                    strNamedColor = "DarkBlue";
                    break;

                case "008B8B":
                    strNamedColor = "DarkCyan";
                    break;

                case "B8860B":
                    strNamedColor = "DarkGoldenrod";
                    break;

                case "A9A9A9":
                    strNamedColor = "DarkGray";
                    break;

                case "006400":
                    strNamedColor = "DarkGreen";
                    break;

                case "BDB76B":
                    strNamedColor = "DarkKhaki";
                    break;

                case "8B008B":
                    strNamedColor = "DarkMagenta";
                    break;

                case "556B2F":
                    strNamedColor = "DarkOliveGreen";
                    break;

                case "FF8C00":
                    strNamedColor = "DarkOrange";
                    break;

                case "9932CC":
                    strNamedColor = "DarkOrchid";
                    break;

                case "8B0000":
                    strNamedColor = "DarkRed";
                    break;

                case "E9967A":
                    strNamedColor = "DarkSalmon";
                    break;

                case "8FBC8F":
                    strNamedColor = "DarkSeaGreen";
                    break;

                case "483D8B":
                    strNamedColor = "DarkSlateBlue";
                    break;

                case "2F4F4F":
                    strNamedColor = "DarkSlateGray";
                    break;

                case "00CED1":
                    strNamedColor = "DarkTurquoise";
                    break;

                case "9400D3":
                    strNamedColor = "DarkViolet";
                    break;

                case "FF1493":
                    strNamedColor = "DeepPink";
                    break;

                case "00BFFF":
                    strNamedColor = "DeepSkyBlue";
                    break;

                case "696969":
                    strNamedColor = "DimGray";
                    break;

                case "1E90FF":
                    strNamedColor = "DodgerBlue";
                    break;

                case "B22222":
                    strNamedColor = "FireBrick";
                    break;

                case "FFFAF0":
                    strNamedColor = "FloralWhite";
                    break;

                case "228B22":
                    strNamedColor = "ForestGreen";
                    break;

                //case "FF00FF":
                //    strNamedColor = "Fuchsia";
                //    break;

                case "DCDCDC":
                    strNamedColor = "Gainsboro";
                    break;

                case "F8F8FF":
                    strNamedColor = "GhostWhite";
                    break;

                case "FFD700":
                    strNamedColor = "Gold";
                    break;

                case "DAA520":
                    strNamedColor = "Goldenrod";
                    break;

                case "808080":
                    strNamedColor = "Gray";
                    break;

                case "008000":
                    strNamedColor = "Green";
                    break;

                case "ADFF2F":
                    strNamedColor = "GreenYellow";
                    break;

                case "F0FFF0":
                    strNamedColor = "Honeydew";
                    break;

                case "FF69B4":
                    strNamedColor = "HotPink";
                    break;

                case "CD5C5C":
                    strNamedColor = "IndianRed";
                    break;

                case "4B0082":
                    strNamedColor = "Indigo";
                    break;

                case "FFFFF0":
                    strNamedColor = "Ivory";
                    break;

                case "F0E68C":
                    strNamedColor = "Khaki";
                    break;

                case "E6E6FA":
                    strNamedColor = "Lavender";
                    break;

                case "FFF0F5":
                    strNamedColor = "LavenderBlush";
                    break;

                case "7CFC00":
                    strNamedColor = "LawnGreen";
                    break;

                case "FFFACD":
                    strNamedColor = "LemonChiffon";
                    break;

                case "ADD8E6":
                    strNamedColor = "LightBlue";
                    break;

                case "F08080":
                    strNamedColor = "LightCoral";
                    break;

                case "E0FFFF":
                    strNamedColor = "LightCyan";
                    break;

                case "FAFAD2":
                    strNamedColor = "LightGoldenrodYellow";
                    break;

                case "90EE90":
                    strNamedColor = "LightGreen";
                    break;

                case "D3D3D3":
                    strNamedColor = "LightGray";
                    break;

                case "FFB6C1":
                    strNamedColor = "LightPink";
                    break;

                case "FFA07A":
                    strNamedColor = "LightSalmon";
                    break;

                case "20B2AA":
                    strNamedColor = "LightSeaGreen";
                    break;

                case "87CEFA":
                    strNamedColor = "LightSkyBlue";
                    break;

                case "778899":
                    strNamedColor = "LightSlateGray";
                    break;

                case "B0C4DE":
                    strNamedColor = "LightSteelBlue";
                    break;

                case "FFFFE0":
                    strNamedColor = "LightYellow";
                    break;

                case "00FF00":
                    strNamedColor = "Lime";
                    break;

                case "32CD32":
                    strNamedColor = "LimeGreen";
                    break;

                case "FAF0E6":
                    strNamedColor = "Linen";
                    break;

                case "FF00FF":
                    strNamedColor = "Magenta";
                    break;

                case "800000":
                    strNamedColor = "Maroon";
                    break;

                case "66CDAA":
                    strNamedColor = "MediumAquamarine";
                    break;

                case "0000CD":
                    strNamedColor = "MediumBlue";
                    break;

                case "BA55D3":
                    strNamedColor = "MediumOrchid";
                    break;

                case "9370DB":
                    strNamedColor = "MediumPurple";
                    break;

                case "3CB371":
                    strNamedColor = "MediumSeaGreen";
                    break;

                case "7B68EE":
                    strNamedColor = "MediumSlateBlue";
                    break;

                case "00FA9A":
                    strNamedColor = "MediumSpringGreen";
                    break;

                case "48D1CC":
                    strNamedColor = "MediumTurquoise";
                    break;

                case "C71585":
                    strNamedColor = "MediumVioletRed";
                    break;

                case "191970":
                    strNamedColor = "MidnightBlue";
                    break;

                case "F5FFFA":
                    strNamedColor = "MintCream";
                    break;

                case "FFE4E1":
                    strNamedColor = "MistyRose";
                    break;

                case "FFE4B5":
                    strNamedColor = "Moccasin";
                    break;

                case "FFDEAD":
                    strNamedColor = "NavajoWhite";
                    break;

                case "000080":
                    strNamedColor = "Navy";
                    break;

                case "FDF5E6":
                    strNamedColor = "OldLace";
                    break;

                case "808000":
                    strNamedColor = "Olive";
                    break;

                case "6B8E23":
                    strNamedColor = "OliveDrab";
                    break;

                case "FFA500":
                    strNamedColor = "Orange";
                    break;

                case "FF4500":
                    strNamedColor = "OrangeRed";
                    break;

                case "DA70D6":
                    strNamedColor = "Orchid";
                    break;

                case "EEE8AA":
                    strNamedColor = "PaleGoldenrod";
                    break;

                case "98FB98":
                    strNamedColor = "PaleGreen";
                    break;

                case "AFEEEE":
                    strNamedColor = "PaleTurquoise";
                    break;

                case "DB7093":
                    strNamedColor = "PaleVioletRed";
                    break;

                case "FFEFD5":
                    strNamedColor = "PapayaWhip";
                    break;

                case "FFDAB9":
                    strNamedColor = "PeachPuff";
                    break;

                case "CD853F":
                    strNamedColor = "Peru";
                    break;

                case "FFC0CB":
                    strNamedColor = "Pink";
                    break;

                case "DDA0DD":
                    strNamedColor = "Plum";
                    break;

                case "B0E0E6":
                    strNamedColor = "PowderBlue";
                    break;

                case "800080":
                    strNamedColor = "Purple";
                    break;

                case "FF0000":
                    strNamedColor = "Red";
                    break;

                case "BC8F8F":
                    strNamedColor = "RosyBrown";
                    break;

                case "4169E1":
                    strNamedColor = "RoyalBlue";
                    break;

                case "8B4513":
                    strNamedColor = "SaddleBrown";
                    break;

                case "FA8072":
                    strNamedColor = "Salmon";
                    break;

                case "F4A460":
                    strNamedColor = "SandyBrown";
                    break;

                case "2E8B57":
                    strNamedColor = "SeaGreen";
                    break;

                case "FFF5EE":
                    strNamedColor = "Seashell";
                    break;

                case "A0522D":
                    strNamedColor = "Sienna";
                    break;

                case "C0C0C0":
                    strNamedColor = "Silver";
                    break;

                case "87CEEB":
                    strNamedColor = "SkyBlue";
                    break;

                case "6A5ACD":
                    strNamedColor = "SlateBlue";
                    break;

                case "708090":
                    strNamedColor = "SlateGray";
                    break;

                case "FFFAFA":
                    strNamedColor = "Snow";
                    break;

                case "00FF7F":
                    strNamedColor = "SpringGreen";
                    break;

                case "4682B4":
                    strNamedColor = "SteelBlue";
                    break;

                case "D2B48C":
                    strNamedColor = "Tan";
                    break;

                case "008080":
                    strNamedColor = "Teal";
                    break;

                case "D8BFD8":
                    strNamedColor = "Thistle";
                    break;

                case "FF6347":
                    strNamedColor = "Tomato";
                    break;

                case "40E0D0":
                    strNamedColor = "Turquoise";
                    break;

                case "EE82EE":
                    strNamedColor = "Violet";
                    break;

                case "F5DEB3":
                    strNamedColor = "Wheat";
                    break;

                case "FFFFFF":
                    strNamedColor = "White";
                    break;

                case "F5F5F5":
                    strNamedColor = "WhiteSmoke";
                    break;

                case "FFFF00":
                    strNamedColor = "Yellow";
                    break;

                case "9ACD32":
                    strNamedColor = "YellowGreen";
                    break;

                default:
                    strNamedColor = "";
                    break;
            }
            return strNamedColor;

        }

        #endregion

        public static int HexToInt(String hexstr)
        //  This method converts a hexvalues string as 80FF into a integer.
        //	Note that you may not put a '#' at the beginning of string! There
        //  is not much error checking in this method. If the string does not
        //  represent a valid hexadecimal value it returns 0.
        {
            int counter, hexint;
            char[] hexarr;
            hexint = 0;
            hexstr = hexstr.ToUpper();
            hexarr = hexstr.ToCharArray();
            for (counter = hexarr.Length - 1; counter >= 0; counter--)
            {
                if ((hexarr[counter] >= '0') && (hexarr[counter] <= '9'))
                {
                    hexint += (hexarr[counter] - 48) * ((int)(Math.Pow(16, hexarr.Length - 1 - counter)));
                }
                else
                {
                    if ((hexarr[counter] >= 'A') && (hexarr[counter] <= 'F'))
                    {
                        hexint += (hexarr[counter] - 55) * ((int)(Math.Pow(16, hexarr.Length - 1 - counter)));
                    }
                    else
                    {
                        hexint = 0;
                        break;
                    }
                }
            }
            return hexint;
        }
